/**
 * Copyright (c) 2016-2018 Thales Global Services S.A.S.
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *   Abel Hegedus, Tamas Borbas, Balazs Grill, Peter Lunk, Daniel Segesdi (IncQuery Labs Ltd.) - initial API and implementation
 */
package org.eclipse.emf.diffmerge.patch.ui.utils;

import com.google.common.base.Objects;
import java.util.Arrays;
import java.util.List;
import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.xtext.xbase.lib.CollectionLiterals;
import org.eclipse.xtext.xbase.lib.Conversions;

@SuppressWarnings("all")
public class ModelPatchEntryFilterContentProvider implements IStructuredContentProvider {
  @Override
  public void dispose() {
  }
  
  @Override
  public void inputChanged(final Viewer viewer, final Object oldInput, final Object newInput) {
  }
  
  @Override
  public Object[] getElements(final Object inputElement) {
    boolean _equals = Objects.equal(inputElement, null);
    if (_equals) {
      return ((Object[])Conversions.unwrapArray(CollectionLiterals.<Object>newArrayList(), Object.class));
    }
    return ((Object[])Conversions.unwrapArray(this.getAllElements(inputElement), Object.class));
  }
  
  private List<?> _getAllElements(final Object object) {
    return CollectionLiterals.<Object>newArrayList();
  }
  
  private List<?> _getAllElements(final List list) {
    return list;
  }
  
  private List<?> getAllElements(final Object list) {
    if (list instanceof List) {
      return _getAllElements((List)list);
    } else if (list != null) {
      return _getAllElements(list);
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(list).toString());
    }
  }
}
